/**
  ******************************************************************************
  * @file    Project/STM32L1xx_StdPeriph_Template/main.h 
  * @author  MCD Application Team
  * @version V1.0.3
  * @date    May-2013
  * @brief   Header for main.c module
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 STMicroelectronics</center></h2>
  ******************************************************************************
  */ 
  
#ifndef __MAIN_H
#define __MAIN_H

#include "stm32l1xx.h"
#include <stdio.h>

#define SAMPLES_SIZE 60
#define SAVE_INTERVAL_HOURS 6
//#define SAVE_INTERVAL_HOURS 1

//4 byte
struct DhtSample
{
  int16_t temperature;
  int16_t humidity;
};

//sizeof(BigIntervalData) < 256
//8 bytes
struct BigIntervalDataHeader
{
  uint8_t saveIntervalHours;
  uint8_t min;      // 0 to 59
  uint8_t hour;     // 0 to 23
  uint8_t mday;     // 1 to 31
  uint8_t mon;      // 1 to 12
  uint8_t year;     // year-99
  uint8_t padder0;
  uint8_t padder1;
};

#ifdef DEBUG
//124 kb to program
#define FLASH_PROGRAM_MAX_SIZE 0x1F000
#else
//32 kb to program
#define FLASH_PROGRAM_MAX_SIZE 0x8000
#endif

//96 kb to data in flash
//debug 4 kb flash
#define FLASH_STORAGE_SIZE (0x20000-FLASH_PROGRAM_MAX_SIZE)
#define FLASH_START_ARRAY  (FLASH_BASE+FLASH_PROGRAM_MAX_SIZE)

#define EEPROM_START_ADDRESS 0x08080000
#define EEPROM_SIZE 0x1000


#endif /* __MAIN_H */

