// balmer@inbox.ru 2013 TermometerHygrometer
#include "display.h"
#include "ti8077_lcd.h"
#include "dht.h"
#include "main.h"

extern int16_t gLastSampleIndex;

void DisplayTemperature(void)
{
	//Format "-00.0@C"
	int16_t t = dht_ok?dht_temperature:0;
	uint8_t c0,c1,c2;
	if(t<0)
	{
		LCD_GLASS_WriteChar('-', false, false, 4);
		t = -t;
	}

	LCD_GLASS_WriteChar('C', false, (gLastSampleIndex&1)?true:false, 0);

	c0 = t%10;
	t/=10;
	c1 = t%10;
	t/=10;
	c2 = t;

	LCD_GLASS_WriteChar(c0+'0', false, false, 1);
	LCD_GLASS_WriteChar(c1+'0', true, false, 2);
	if(c2>0)
		LCD_GLASS_WriteChar(c2+'0', false, false, 3);
}

void Display2(uint8_t data, uint8_t position)
{
	uint8_t c1,c2;
	c1 = data%10;
	data/=10;
	c2 = data%10;
	LCD_GLASS_WriteChar(c1+'0', true, false, position);
	LCD_GLASS_WriteChar(c2+'0', false, false, position+1);
}


void DisplayHumidity(void)
{
	int16_t h = dht_ok?dht_humidity:0;
	LCD_GLASS_WriteChar('H', false, false, 5);
	uint8_t c1,c2;
	h/=10;
	c1 = h%10;
	h/=10;
	c2 = h;
	LCD_GLASS_WriteChar(c1+'0', false, false, 6);
	if(c2>0)
		LCD_GLASS_WriteChar(c2+'0', false, false, 7);
}

void DisplayClock(void)
{
	//HH MM SS
	RTC_TimeTypeDef time;
	RTC_DateTypeDef date;
	RTC_GetTime(RTC_Format_BIN, &time);
	RTC_GetDate(RTC_Format_BIN, &date);

	Display2(date.RTC_Date, 6);
	Display2(time.RTC_Hours, 4);
	Display2(time.RTC_Minutes, 2);
	Display2(time.RTC_Seconds, 0);
}

void Display(void)
{
	LCD_GLASS_Clear();

	//DisplayClock();
	DisplayTemperature();
	DisplayHumidity();

	LCD_UpdateDisplayRequest();
}

void DisplayUsb(void)
{
	LCD_GLASS_Clear();
	LCD_GLASS_DisplayString("U58");
	LCD_UpdateDisplayRequest();
}
